#TEMPLATE(ksUI,'Adding ksUI features'), FAMILY('ABC'), FAMILY('CW20'), FAMILY('CLARION')
#!====================================================================================================================
#! Adding ksUI features to a Clarion app
#!====================================================================================================================
#EXTENSION(ksUIGlobal,'ksUI Global Settings'),DESCRIPTION('ksUI Global Settings'),APPLICATION
#SHEET
#TAB('General')
#BOXED ('Global ksUI extension for the application')
#DISPLAY()
#PROMPT('Key combination to call ksUI',KEYCODE),%KSUIGlobalAlertKey,UNIQUE,REQ
#PROMPT('Use Global Variable to enable ksUI', CHECK), %KSUIGlobalCondition,DEFAULT(%FALSE),AT(10)
#ENABLE(%KSUIGlobalCondition)
#PROMPT('Global variable:', @s128), %KSUIGlobalVar,REQ
#ENDENABLE
#DISPLAY('You can either use procedure extension template or')
#PROMPT('apply ksUI to all WINDOW procedures', CHECK), %KSUIApplyToAll,DEFAULT(%FALSE),AT(10)
#ENABLE(%KSUIApplyToAll)
#PROMPT('Global KSUI:param', @s128), %KSUIGlobalParam,REQ,DEFAULT('GLO:KSUIparam')
#ENDENABLE
#PROMPT('Prompt to save when exiting ksUI mode', CHECK), %KSUIPromptOnExit,DEFAULT(%FALSE),AT(10)
#DISPLAY
#PROMPT('Support E-Mail:',@S200),%CompanyMail,DEFAULT('support@klarisoft.com'),PROP(PROP:ReadOnly,1),PROP(PROP:Skip,1)
#PROMPT('Official Site:',@S200),%CompanySite,DEFAULT('http://www.klarisoft.com'),PROP(PROP:ReadOnly,1),PROP(PROP:Skip,1)
#DISPLAY()
#ENDBOXED
#ENDTAB
#TAB('Optional Settings')
#DISPLAY ('')
#PROMPT('Path to ksUI:', @s128),%KSUIPath
#DISPLAY ('(exe path if blank)')
#PROMPT('Password:', @s128),%KSUIPassword
#ENDTAB
#ENDSHEET
#!====================================================================================================================
#AT (%GlobalMap)
MODULE('ksUI.lib')
       KSUI:ProcessWindow(window,long,string,string,<ksUISettings>),DLL(dll_mode)
       KSUI:SetWindowControls(WINDOW TheWindow,STRING ProcedureName,STRING pID,<ksUISettings>),DLL(dll_mode)
END
#ENDAT
#!====================================================================================================================
#AT(%CustomGlobalDeclarations)
#IF(SLICE(%CWVersion,1,1)='6')
    #PROJECT('C60ksUIx.LIB')
#ELSIF(SLICE(%CWVersion,1,1)='7' OR SLICE(%CWVersion,1,1)='8' OR SLICE(%CWVersion,1,1)='9')
    #PROJECT('CLAksUI.LIB')
#ENDIF
#ENDAT
#AT (%BeforeGlobalIncludes)
  INCLUDE('ksui.equ'),once
#ENDAT

#AT (%GlobalData)
#IF(CLIP(%KSUIGlobalParam)<>'')
GLO:KSUIparam        STRING('MAIN {76}')
GLO:ksUISettings     LIKE(ksUISettings)
#ENDIF
#ENDAT

#AT(%WindowEventHandling,'AlertKey')
  #IF ((%Window) AND (%KSUIApplyToAll))
CASE KEYCODE()
OF %KSUIGlobalAlertKey
#IF (%KSUIGlobalCondition)
  IF %KSUIGlobalVar
#ENDIF
    KSUI:ProcessWindow(%window,?,'%Procedure',%KSUIGlobalParam,GLO:ksUISettings)
#IF (%KSUIGlobalCondition)
  END
#ENDIF
END
  #ENDIF
#ENDAT

#AT(%AfterWindowOpening)
  #IF ((%Window) AND (%KSUIApplyToAll))
  #IF (Clip(%KSUIPath)<>'')
  GLO:ksUISettings.ksUIPath = %KSUIPath
  #ENDIF
  #IF (Clip(%KSUIPassword)<>'')
  GLO:ksUISettings.Password = %KSUIPassword
  #ENDIF
  #IF (%KSUIPromptOnExit)
  GLO:ksUISettings.PromptOnExit= TRUE
  #ENDIF
#IF (%KSUIGlobalCondition)
  IF %KSUIGlobalVar
#ENDIF
  KSUI:SetWindowControls(%window,'%Procedure',%KSUIGlobalParam,GLO:ksUISettings)
  DISPLAY
  %Window{PROP:Alrt,255} = %KSUIGlobalAlertKey !Global Keycode to start KSUI:ProcessWindow
#IF (%KSUIGlobalCondition)
  END
#ENDIF
  #ENDIF
#ENDAT

#!====================================================================================================================
#EXTENSION (ksUI,'Use ksUI on a Window'),SHOW,REQ(ksUIGlobal)
#!
#DISPLAY ('This template applies ksUI setting to a window')
#DISPLAY ('')
#BOXED
#PROMPT ('ksUI parameter:', @s128 ),%KSUIParam,DEFAULT('!KSUI:param')
#DISPLAY('To support different setting for the same window' )
#DISPLAY('set KSUI:param value' )
#DISPLAY('You can use string constant or variable (prefixed with !).')
#DISPLAY('When set to ''ORIGINAL'' then original window settings are used')
#PROMPT('Use condition to show ksUI screen', CHECK), %KSUICondition,DEFAULT(%FALSE),AT(10)
#ENABLE(%KSUICondition)
#PROMPT('Condition variable:', OPTFIELD), %KSUIConditionVar,REQ
#ENDENABLE
#ENDBOXED
#DECLARE( %TempKSUI )
#LOCALDATA
KSUI:param          STRING('MAIN {76}')
LOC:ksUISettings    LIKE(ksUISettings)
#ENDLOCALDATA

#AT(%AfterWindowOpening)
  #IF ((%Window) AND (%KSUIApplyToAll)=%FALSE)
    #IF (Clip(%KSUIPath)<>'')
  LOC:ksUISettings.ksUIPath = %KSUIPath
    #ENDIF
    #IF (Clip(%KSUIPassword)<>'')
  LOC:ksUISettings.Password = %KSUIPassword
    #ENDIF
    #IF (%KSUIPromptOnExit)
  LOC:ksUISettings.PromptOnExit= TRUE
    #ENDIF
    #IF( SUB(%KSUIParam,1,1) = '!' )
      #IF(NOT VAREXISTS(%TempKSUI))
        #DECLARE( %TempKSUI )
      #ENDIF
      #SET( %TempKSUI, SUB( %KSUIParam, 2, LEN( %KSUIParam ) ) )
  KSUI:SetWindowControls(%window,'%Procedure',%TempKSUI,LOC:ksUISettings)
    #ELSE
  KSUI:SetWindowControls(%window,'%Procedure','%KSUIParam',LOC:ksUISettings)
    #ENDIF
  DISPLAY
  %Window{PROP:Alrt,255} = %KSUIGlobalAlertKey !Keycode to start KSUI:ProcessWindow
  #ENDIF
#ENDAT

#!====================================================================
#AT(%WindowEventHandling,'AlertKey')
  #IF ((%Window) AND (%KSUIApplyToAll)=%FALSE)
CASE KEYCODE()
OF %KSUIGlobalAlertKey
#IF (%KSUIGlobalCondition)
  IF %KSUIGlobalVar
#ENDIF
#IF (%KSUICondition)
  IF %KSUIConditionVar
#ENDIF
#IF( SUB(%KSUIParam,1,1) = '!' )
#IF(NOT VAREXISTS(%TempKSUI))
#DECLARE( %TempKSUI )
#ENDIF
#SET( %TempKSUI, SUB( %KSUIParam, 2, LEN( %KSUIParam ) ) )
    KSUI:ProcessWindow(%window,?,'%Procedure',%TempKSUI,LOC:ksUISettings)
#ELSE
    KSUI:ProcessWindow(%window,?,'%Procedure','%KSUIParam',LOC:ksUISettings)
#ENDIF
#IF (%KSUICondition)
  END
#ENDIF
#IF (%KSUIGlobalCondition)
  END
#ENDIF
END
  #ENDIF
#ENDAT
!====================================================================
